# cc2-MI.py - Nice, Automne 2016
# Section L1-Math-Info

# Q1

L1 = [2*i for i in range(2)]
L2 = [L1,L1,L1 + L1]          # [L1 original, L1 original, copie] !
print('L1 =',L1,'et L2 =',L2)
L1[0] = 10
print('L1 =',L1,'et L2 =',L2)
print()

######################################################################################

# Q2

def que_des_pairs(n) :    # on pourrait aussi passer par les string, bof...
    while n > 0 :
        if n % 2  == 1 : return False
        n = n // 10
    return True

if que_des_pairs(214) : raise ValueError('Bug dans que_des_pairs')
if not que_des_pairs(2048) : raise ValueError('Bug dans que_des_pairs')

######################################################################################

# Q3
# Reconstruction d'un entier à partir de la liste de ses chiffres décimaux
# ET SURTOUT PAS L'HORRIBLE ALGORITHME QUI UTILISE LES PUISSANCES DE 10 !!
# Schéma de Hörner...

def list2int(L) :
    acc = 0                 # l'algorithme vu en TD...
    for k in L :
        acc = acc * 10 + k
    return acc

if list2int([2,0,1,6]) != 2016 : raise ValueError('Bug dans list2int')

########################################################################################

# Q4
# Aucune mutation sur L. 

def remplace(x,y,L) :
    res = []
    for e in L :
        if e == x : res.append(y)     # mais mutation ok sur une variable locale !
        else : res.append(e)
    return res

def remplace(x,y,L) :                 # un poil plus joli...
    def transforme(e) :
        if e == x : return y
        return e
    return [transforme(e) for e in L]

L = [5,8,3,7,3,3,9]
if remplace(3,5,L) != [5,8,5,7,5,5,9] : raise ValueError('Bug1 dans remplace')
if L != [5,8,3,7,3,3,9] : raise ValueError('Bug2 dans remplace')   # aucune mutation !

###################################################################################

# Q5
# Une matrice à p lignes et q colonnes - on dit "de format (p,q)" - est représentée
# par une liste de p lignes, chaque ligne étant une liste de q nombres. Par exemple :
A = [[2,3,-1],[5,0,6]] ; B = [[5,1,0],[4,2,2]]   # matrices de format (2,3). En maths :
#        (2  3  -1)             (5  1  0)
#        (5  0   6)             (4  2  2)
# Programmez une fonction add_mat(A,B) prenant deux matrices A et B. Cette fonction
# va déclencher une erreur 'Formats incompatibles' dans le cas où A et B ne sont pas
# de même format. Sinon, elle retourne la matrice somme de A et B (addition composante
# à composante).

def nblig(M) : return len(M)
def nbcol(M) : return len(M[0])

def add_mat(A,B) :
    if nblig(A) != nblig(B) or nbcol(A) != nbcol(B) :
        raise ValueError('Formats incompatibles pour +')
    return [[A[i][j] + B[i][j] for j in range(nbcol(A))] for i in range(nblig(A))]

def add_mat(A,B) :   # version plus lourde :-(
    if nblig(A) != nblig(B) or nbcol(A) != nbcol(B) :
        raise ValueError('Formats incompatibles pour +')
    res = [nbcol(A) * [0] for i in range(nblig(A))]   # une matrice nulle
    # on remplit maintenant la matrice nulle par la somme de A et B
    for i in range(nblig(A)) :
        for j in range(nbcol(A)) :
            res[i][j] = A[i][j] + B[i][j]
    return res

if add_mat(A,B) != [[7,4,-1],[9,2,8]] : raise ValueError('Bug dans add_mat')
print('add_mat semble correcte')
print()

###################################################################################

# Q6 - Polycreux
from polycreux import *

def poly_rac(L) :   # le polynome minimal ayant pour racines les éléments de L
    res = [[1,0]]
    for e in L :
        res = mul(res,[[1,1],[-e,0]])
    return res

p = poly_rac([3,1,2])    # (X-3)(X-1)(X-2) = X^3-6X^2+11X-6
print('Polynôme de racines 1,2,3 :',p)    # [[1, 3],[-6, 2],[11, 1],[-6, 0]]
print()

####################################################################################

# Q7 - Dictionnaire

stock = {'pommes':65, 'poires':18, 'bananes':25, 'pêches':65, 'abricot':12}
# Afficher la liste des fruits en nombre > 20 ?
print([fruit for fruit in stock if stock[fruit] > 20]) 
# Le nombre total de fruits
print(sum(stock[k] for k in stock))
print(sum(stock.values()))   # encore plus court... stock.values() est un iterable !

# CQFP











