# cc2-gr1.py - Nice, Automne 2016
# Section L1-Info

def est_premier(n) :    # non demandé, donné !
    def ppdiv(n) :      # on suppose n >= 2
        if n % 2 == 0 : return 2
        for d in range(3,n,2) :
            if d * d > n : return n
            if n % d == 0 : return d
    return n >= 2 and ppdiv(n) == n

######################################################################################

# Q1

L= [[2*i,i] for i in range(3)]
print('L =',L)
L[1] = L[2] ; L[2] = L[1]
print('L =',L)
L[1][0] = 0
print('L =',L)
L[1] = 0
print('L =',L)
print()

######################################################################################

# Q2

# La liste L des entiers premiers < 100000 comportant exactement trois fois le chiffre 7
L = []
for k in range(2,10000) :
    if est_premier(k) and str(k).count('7') == 3 :
        L.append(k)
print(L,'et le plus grand est',L[-1])

# Autre solution par compréhension de liste :
L = [k for k in range(2,10000) if est_premier(k) and str(k).count('7') == 3]
print(L,'et le plus grand est',L[-1])
print()

######################################################################################

# Q3

def chiffres(n) :    # on suppose n entier > 0
    res = []
    while n != 0 :
        res.append(n % 10)
        n = n // 10
    return res[::-1] # on inverse à la fin !

print('chiffres(12334) =',chiffres(12334))

def chiffres(n) :    # on suppose n entier > 0
    res = []
    while n != 0 :
        res = [n % 10] + res
        n = n // 10
    return res

print('chiffres(12334) =',chiffres(12334))

def chiffres(n) :    # Pourquoi faire compliqué ? On passe par les string :-)
    return [int(c) for c in str(n)]

print('chiffres(12334) =',chiffres(12334))
print()

########################################################################################

# Q4

def remplace(x,y,L) :     # x remplace y dans L. Mutation !
    for i in range(len(L)) :
        if L[i] == y : L[i] = x

LIS = [5,8,4,6,8,8]
remplace(0,8,LIS)    
if LIS != [5,0,4,6,0,0] : raise ValueError('Bug dans remplacer !')
print()

###################################################################################

# Q5
from random import randint
from turtle import *

def executer(r) :
    dist = 0
    for (op,arg) in r :
        if op == 'F' :
            forward(arg)
            dist = dist + abs(arg)
        else :
            left(arg)
    return dist

# un exemple avec un ruban choisi au hasard. Non demandé.
from random import randint
rub = []
for i in range(30) :
    if randint(0,1) == 0 : op = 'F'
    else : op = 'L'
    rub.append((op,randint(-30,30)))
print('rub =',rub)
print('Distance parcourue pour ce ruban rub :',executer(rub))
print()

# Q5b
# La question à laquelle vous avez échappé faute de place : compactez un ruban en remplaçant
# chaque suite de 'F' consecutifs par un seul 'F' et idem pour chaque suite de 'L' consécutifs.

##########################################################################################

# Q6a - Polycreux

from polycreux import *

# Donnez l'expression mathematique de V4
# Rép : X^4 + 6X^2 + 3X

# Q6b

def deriv(p) :     # fait en TP !
    return [[c*e,e-1] for [c,e] in p if e > 0]

if deriv([[3,2],[-1,1],[3,0]]) != [[6,1],[-1,0]] : raise ValueError('Bug dans deriv')
print('deriv semble correcte')

def valrose(n) :         # le polynome de Valrose numéro n
    if n == 0 : return [[1,0]]
    HR = valrose(n-1)    # hyp. de récurrence 
    return add(mul([[1,1]],HR),deriv(HR))

for n in range(6) : print('valrose({}) ='.format(n),valrose(n))
print()








