# cc2-gr3.py - Automne 2016
# Section L1-Math-Info

def est_premier(n) :    # non demandé, donné !
    def ppdiv(n) :      # on suppose n >= 2
        if n % 2 == 0 : return 2
        for d in range(3,n,2) :
            if d * d > n : return n
            if n % d == 0 : return d
    return n >= 2 and ppdiv(n) == n
########################################################################

# Q1

L= [[i,i+1] for i in range(3)]
print('L =',L)
L[0] = L[1]
print('L =',L)
L[0][0] = L[0][0] + 1
print('L =',L)
L[1] = 0
print('L =',L)

# Q2

nb = 0
for k in range(2,100000) :
    if est_premier(k) and '2' not in str(k) :
        maxi = k
        nb = nb + 1
print('Il y en a',nb,'et le plus grand est',maxi)

# Autre solution qui a l'inconvénient de consommer une liste en mémoire :
L = [p for p in range(2,100000) if est_premier(p) and '2' not in str(p)]
print('Il y en a',len(L),'et le plus grand est',L[-1])
print()

######################################################################################

# Q3a

def liste(f,p,a,b) :   # itérative usuelle
    res = []
    for x in range(a,b+1) :
        if p(x) : res.append(f(x))
    return res

def liste(f,p,a,b) :   # mieux : comprehension de liste
    return [f(x) for x in range(a,b+1) if p(x)]

# Q3b

print('La liste des carrés des nombres premiers de [5,15] vaut :',end=' ')
print(liste(lambda x : x*x, est_premier, 5, 15))
print()

########################################################################################

# Q4a
from turtle import *
from random import randint

def promenade(n) :
    res = []
    for i in range(n) :
        left(randint(0,359))      # left avant forward !
        forward(50)
        res.append(pos())
    return res

L = promenade(20)
print('promenade(20) =',L)

# Q4b

# Afficher le point le plus bas atteint par la tortue.
ymin = min([y for (x,y) in L])    # calcul de l'ordonnée la plus basse
for (x,y) in L :                  # recherche du point ayant cette ordonnée ymin
    if y == ymin :
        print('Point le plus bas :',(x,y))
        break                     # Toujours couper un calcul dès que possible !!!
    
# Le point trouvé semble avoir d'autres décimales que celui qui est affiché dans la liste,
# mais ceci est dû au choix de Python d'afficher un nombre *approché*. Vérifions quand même :
if (x,y) in L : print('Ok, il est bien dans L')

# Autre méthode un peu plus efficace, algorithme de recherche usuelle d'un minimum :
ymin = float('inf')
for (x,y) in L :
    if y < ymin : ymin = y ; dernier = (x,y)
print('Point le plus bas :',dernier)
print()

##########################################################################################

# Q5 - Polycreux

from polycreux import *
# L'enoncé rappelle l'algo de puissance par dichotomie dans les entiers naturels !

def puis(p,k) :   # le polynome p^k par dichotomie et récurrence
    if k == 0 : return [[1,0]]
    if k % 2 == 0 : return puis(mul(p,p),k // 2)
    return mul(p,puis(p,k-1))

print('(X-1)^3 -->',puis([[1,1],[-1,0]],3))
print('(X+1)^2 -->',puis([[1,1],[1,0]],2))







